//////////////////////////////////////////////////////////////////
// Function file for Armed Assault
// Created by: -eutf-Myke
// nul = [[vehicles], [startpos], [droppos], [finaltargets], side, true/flase] execVM "the_ambush.sqf"
//////////////////////////////////////////////////////////////////
if (! isServer) exitwith {};
if (count _this < 6) exitwith {hint "Error!\n\nMissing parameter in scriptcall"};
private ["_vehicle_array", "_start_array", "_drop_array", "_target_array", "_side", "_chute_bool", "_pilot_class"];
private ["_crew_class", "_unit_class", "_my_vehicle", "_pilots_group", "_my_pilot", "_my_gunner", "_my_commander"];
private ["_cargo_seats", "_inf_group", "_unit_type", "_unit", "_pilot_type", "_the_marker"];
_vehicle_array = _this select 0;
_start_array = _this select 1;
_drop_array = _this select 2;
_target_array = _this select 3;
_side = _this select 4;
_chute_bool = _this select 5;
if ((count _start_array) < (count _vehicle_array)) exitwith {hint format ["Error!\n\n%1 starting positions.\n%2 required.", count _start_array, count _vehicle_array]};
if ((count _drop_array) < (count _vehicle_array)) exitwith {hint format ["Error!\n\n%1 drop positions.\n%2 required.", count _drop_array, count _vehicle_array]};
createcenter _side;
switch (_side) do
	{
	case WEST:
		{
		_pilot_class = amb_west_units select 0;
		_crew_class = amb_west_units select 1;
		_unit_class = amb_west_units select 2;
		};
	case EAST:
		{
		_pilot_class = amb_east_units select 0;
		_crew_class = amb_east_units select 1;
		_unit_class = amb_east_units select 2;
		};
	case Resistance:
		{
		_pilot_class = amb_racs_units select 0;
		_crew_class = amb_racs_units select 1;
		_unit_class = amb_racs_units select 2;
		};
	case Civilian:
		{
		_pilot_class = amb_civ_units select 0;
		_crew_class = amb_civ_units select 1;
		_unit_class = amb_civ_units select 2;
		};
	};
{
_drop_pos = _drop_array select (floor (random (count _drop_array)));
_drop_array = _drop_array - [_drop_pos];
_the_marker = _start_array select (floor (random (count _start_array)));
_my_vehicle = _x createvehicle getmarkerpos _the_marker;
_start_array = _start_array - [_the_marker];
_pilots_group = creategroup _side;
_driverseats = _my_vehicle emptypositions "Driver";
_gunnerseats = _my_vehicle emptypositions "Gunner";
_commanderseat = _my_vehicle emptypositions "Commander";
if (_driverseats == 1) then
	{
	_pilot_type = _pilot_class select (floor (random (count _pilot_class)));
	_my_pilot =  _pilot_type createunit [position _my_vehicle, _pilots_group, "my_pilot = this"];
	my_pilot assignasdriver _my_vehicle;
	my_pilot moveindriver _my_vehicle;
	sleep 0.1;
	};
if (_gunnerseats == 1) then
	{
	_my_gunner = _pilot_type createunit [position _my_vehicle, _pilots_group, "my_gunner = this"];
	my_gunner assignasgunner _my_vehicle;
	my_gunner moveingunner _my_vehicle;
	sleep 0.1;
	};
if (_commanderseats == 1) then
	{
	_my_commander = _pilot_type createunit [position _my_vehicle, _pilots_group, "my_commander = this"];
	my_commander assignascommander _my_vehicle;
	my_commander moveincommander _my_vehicle;
	sleep 0.1;
	};
_cargo_seats = _my_vehicle emptypositions "cargo";
if (_cargo_seats > 3) then
	{
	_inf_group = creategroup _side;
	for [{_i=0}, {_i<_cargo_seats}, {_i=_i+1}] do
		{
		_unit_type = _unit_class select (floor (random (count _unit_class)));
		_unit = _unit_type createunit [position _my_vehicle, _inf_group, "my_unit = this"];
		my_unit assignascargo _my_vehicle;
		my_unit moveincargo _my_vehicle;
		sleep 0.1;
		};
	_inf_group setbehaviour "CARELESS";
	_inf_group setCombatMode "GREEN";
	};
if (isnull _inf_group) then
	{
	_inf_group = _pilots_group;
	};
_nul = [_my_vehicle, _pilots_group, _drop_pos, _target_array, _chute_bool, _inf_group] execVM "ambush\amb_move.sqf";
}
foreach _vehicle_array;